regina::GraphTriple Class Reference
Standard 3-Manifolds

Represents a closed graph manifold formed by joining three bounded Seifert fibred spaces along their torus boundaries. More...

`#include <manifold/graphtriple.h>`

Inheritance diagram for regina::GraphTriple:

## Public Member Functions

| GraphTriple (SFSpace *end0, SFSpace *centre, SFSpace *end1, const Matrix2 &matchingReln0, const Matrix2 &matchingReln1)
| Creates a new graph manifold from three bounded Seifert fibred spaces, as described in the class notes. More...
| ~GraphTriple ()
| Destroys this structure along with the component Seifert fibred spaces and matching matrices. More...
const SFSpace & | end (unsigned which) const
| Returns a reference to one of the two end spaces. More...
const SFSpace & | centre () const
| Returns a reference to the central space. More...
const Matrix2 & | matchingReln (unsigned which) const
| Returns a reference to the 2-by-2 matrix describing how the two requested bounded Seifert fibred spaces are joined together. More...
bool | operator< (const GraphTriple &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this space is "smaller" than the given representation of the given space. More...
AbelianGroup * | homology () const
| Returns the first homology group of this 3-manifold, if such a routine has been implemented. More...
bool | isHyperbolic () const
| Returns whether or not this is a finite-volume hyperbolic manifold. More...
std::ostream & | writeName (std::ostream &out) const
| Writes the common name of this 3-manifold as a human-readable string to the given output stream. More...
std::ostream & | writeTeXName (std::ostream &out) const
| Writes the common name of this 3-manifold in TeX format to the given output stream. More...
std::string | name () const
| Returns the common name of this 3-manifold as a human-readable string. More...
std::string | TeXName () const
| Returns the common name of this 3-manifold in TeX format. More...
std::string | structure () const
| Returns details of the structure of this 3-manifold that might not be evident from its common name. More...
virtual Triangulation< 3 > * | construct () const
| Returns a triangulation of this 3-manifold, if such a construction has been implemented. More...
AbelianGroup * | homologyH1 () const
| Returns the first homology group of this 3-manifold, if such a routine has been implemented. More...
bool | operator< (const Manifold &compare) const
| Determines in a fairly ad-hoc fashion whether this representation of this 3-manifold is "smaller" than the given representation of the given 3-manifold. More...
virtual std::ostream & | writeStructure (std::ostream &out) const
| Writes details of the structure of this 3-manifold that might not be evident from its common name to the given output stream. More...
void | writeTextShort (std::ostream &out) const
| Writes a short text representation of this object to the given output stream. More...
void | writeTextLong (std::ostream &out) const
| Writes a detailed text representation of this object to the given output stream. More...
std::string | str () const
| Returns a short text representation of this object. More...
std::string | utf8 () const
| Returns a short text representation of this object using unicode characters. More...
std::string | detail () const
| Returns a detailed text representation of this object. More...

## Detailed Description

Represents a closed graph manifold formed by joining three bounded Seifert fibred spaces along their torus boundaries.

There must be one Seifert fibred space at either end, each with a single torus boundary (corresponding to a single puncture in the base orbifold, with no fibre-reversing twist around this puncture). Each of these end spaces is joined to the space in the centre, which has two disjoint torus boundaries (corresponding to two punctures in the base orbifold, again with no fibre-reversing twists around these punctures).

This configuration is illustrated in the diagram below. The large boxes represent the bounded Seifert fibred spaces, and the small tunnels show how their boundaries are joined.

        /---------------\   /-----------------\   /---------------\
        |               |   |                 |   |               |
        |  End space 0   ---   Central space   ---   End space 1  |
        |                ---                   ---                |
        |               |   |                 |   |               |
        ---------------/   -----------------/   ---------------/

The way in which each pair of spaces is joined is specified by a 2-by-2 matrix. This matrix expresses the locations of the fibres and base orbifold of the corresponding end space in terms of the central space. Note that these are not the same matrices that appear in the manifold name in the census data files! See the warning below.

More specifically, consider the matrix M that describes the joining of the central space and the first end space (marked above as end space 0). Suppose that f and o are generators of the common boundary torus, where f represents a directed fibre in the central space and o represents the oriented boundary of the corresponding base orbifold. Likewise, let f0 and o0 be generators of the common boundary torus representing a directed fibre and the base orbifold of the first end space. Then the curves f, o, f0 and o0 are related as follows:

        [f0]       [f ]
        [  ] = M * [  ]
        [o0]       [o ]

Likewise, let matrix M' describe the joining of the central space and the second end space (marked in the diagram above as end space 1). Let f' and o' be curves on the common boundary torus representing the fibres and the base orbifold of the central space, and let f1 and o1 be curves on this same torus representing the fibres and the base orbifold of the second end space. Then the curves f', o', f1 and o1 are related as follows:

        [f1]        [f']
        [  ] = M' * [  ]
        [o1]        [o']

See the page on Notation for Seifert fibred spaces for details on some of the terminology used above.

The optional Manifold routine homology() is implemented, but the optional routine construct() is not.

Warning
  The 2-by-2 matrices used in this class are not the same matrices that appear in the manifold name returned by name() and TeXName() and seen in the census data files. The matrices used in this class work from the inside out, describing the boundary torus on each end space in terms of a boundary torus on the central space. The matrices used in the manifold name work from left to right in the diagram above, describing a boundary torus on the central space or rightmost end space in terms of a boundary torus on the leftmost end space or central space respectively. The upshot of all this is that the first matrix becomes inverted (and the second matrix remains unchanged). It is likely that future versions of Regina will replace this class with a more general class that (amongst other things) removes this inconsistency.

Todo:
  Optimise: Speed up homology calculations involving orientable base spaces by adding rank afterwards, instead of adding generators for genus into the presentation matrix.

## Member Function Documentation

## detail()

std::string regina::Output< Manifold , false >::detail | ( |  | ) | const

inherited

Returns a detailed text representation of this object.

This text may span many lines, and should provide the user with all the information they could want. It should be human-readable, should not contain extremely long lines (which cause problems for users reading the output in a terminal), and should end with a final newline. There are no restrictions on the underlying character set.

Returns
  a detailed text representation of this object.

## str()

std::string regina::Output< Manifold , false >::str | ( |  | ) | const

inherited

Returns a short text representation of this object.

This text should be human-readable, should fit on a single line, and should not end with a newline. Where possible, it should use plain ASCII characters.

Python:\n In addition to str(), this is also used as the
  Python "stringification" function `__str__()`.

Returns
  a short text representation of this object.

## utf8()

std::string regina::Output< Manifold , false >::utf8 | ( |  | ) | const

inherited

Returns a short text representation of this object using unicode characters.

Like str(), this text should be human-readable, should fit on a single line, and should not end with a newline. In addition, it may use unicode characters to make the output more pleasant to read. This string will be encoded in UTF-8.

Returns
  a short text representation of this object.

The documentation for this class was generated from the following file:

- manifold/graphtriple.h

Copyright © 1999-2016, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@maths.uq.edu.au).